#ifndef DICK_IN
#define DICK_IN

#define PTID_START 1000
#define MAXPLAYERS 64

#define COMPILE_FOR_QCDE
#define D3D_TEMP_PROJ_TID 900001

#define D3D_MOVE_WINDOW 1.5

#define D3D_LIZARD_SPITNAME "SPATON"
#define D3D_LIZARD_SPITFRAMES 17
#define D3D_LIZARD_SPITHUDID 974

#define D3D_MORTAR_SPEED 256
#define D3D_BLORD_ANGLEVAR 0.022 // 8 / 360

#define D3D_QUEEN_SPAWNDISTMAX 160.0
#define D3D_QUEEN_DEGREE_INC 4.0

#define D3D_PIGSHIELD_HP 90000
#define D3D_PIGSHIELD_ACTORS 2
#define D3D_PIGSHIELD_TIER 300
#define D3D_PIGSHIELD_HPTIER1 (D3D_PIGSHIELD_ACTORS * D3D_PIGSHIELD_HP) - D3D_PIGSHIELD_TIER
#define D3D_PIGSHIELD_HPTIER2 (D3D_PIGSHIELD_ACTORS * D3D_PIGSHIELD_HP) - (2 * D3D_PIGSHIELD_TIER)

// is 4:3, 16:9 or 16:10
int PlayerAspectRatios[MAXPLAYERS];

enum {
	ASPECT_4_3,
	ASPECT_5_4,
	ASPECT_16_9,
	ASPECT_16_10
};

enum {
	D3D_GRENADE_TANK,
	D3D_GRENADE_BATTLELORD,
	D3D_GRENADE_PIGBRUTE
};

enum {
	D3D_PAINCOOLDOWN_COMM = 1,
	D3D_PAINCOOLDOWN_BLORD,
	D3D_PAINCOOLDOWN_OVERLORD,
	D3D_PAINCOOLDOWN_QUEEN
};

#define D3D_MAX_PAINCOOLDOWNS D3D_PAINCOOLDOWN_QUEEN + 1
str D3D_PainCooldowns[D3D_MAX_PAINCOOLDOWNS] = {
	"CommanderPainCooldown",
	"BattlelordPainCooldown",
	"OverlordPainCooldown",
	"QueenPainCooldown"
};

#define D3D_MAX_GRENADES D3D_GRENADE_PIGBRUTE + 1
str D3D_Grenades[D3D_MAX_GRENADES] = {
	"PigTankMortar",
	"BattlelordMortar",
	"PigBruteMortar"
};

str PigAssaultShieldMonitor[D3D_PIGSHIELD_ACTORS] = {
	"PigHitboxHP_Front",
	"PigHitboxHP_Side"
};

int abs (int x) {
	if(x < 0)
		return -x;
	return x;
}

// Copied from ZDWiki.
// Fixed-point version, only works up to 30,000 or so:
int fsqrt(int number) 
{ 
  int samples = 15; // Samples for accuracy

  if (number == 1.0) return 1.0; 
  if (number <= 0) return 0;
  int val = samples<<17 + samples<<19; // x*10 = x<<1 + x<<3
  for (int i=0; i<samples; ++i) 
    val = (val + FixedDiv(number, val)) >> 1;

  return val; 
}

int max(int a, int b) {
	if(a > b)
		return a;
	return b;
}

int sqrt_z(int number)
{
	if(number <= 3)
	{
		if(number > 0)
		{
			return 1;
		}
		return 0;
	}
	
	int oldAns = number >> 1,                     
	    newAns = (oldAns + number / oldAns) >> 1; 
	
	while(newAns < oldAns)
	{
		oldAns = newAns;
		newAns = (oldAns + number / oldAns) >> 1;
	}

	return oldAns;
}

// takes deltax and deltay as parameter for actor comparisons
int GetDistance(int dx, int dy) {
	dx >>= 16;
	dy >>= 16;
	return sqrt_z(dx * dx + dy * dy);
}

int magnitudeThree(int x, int y, int z) {
    return sqrt_z(x*x + y*y + z*z);
}

void LineDraw(str actortype, int sx, int sy, int sz, int dx, int dy, int dz, int density) {
    int vX;  int vY;   int vZ;
    int nX;  int nY;   int nZ;
    int bX;  int bY;   int bZ;
    int magnitude;
    int pointCount;
    int pointOffset;
    vX   = dx - sx;       vY   = dy - sy;       vZ   = dz - sz;

    magnitude = magnitudeThree(vX >> 16, vY >> 16, vZ >> 16);

    pointCount  = magnitude / density;
    pointOffset = magnitude - (pointCount * density);

    if (magnitude != 0) {
        nX = vX / magnitude; nY = vY / magnitude; nZ = vZ / magnitude;

        int i; int j;
        for (i = 1; i < pointCount; i++) {
            j = (i * density) + pointOffset;

            bX = (nX * j) + sx;
            bY = (nY * j) + sy;
            bZ = (nZ * j) + sz;

			SpawnForced(actortype, bX, bY, bZ);
        }
    }
}

int GetPigShieldHPSum(int pig) {
	int res = 0;
	for(int i = 0; i < D3D_PIGSHIELD_ACTORS; ++i)
		res += CheckActorInventory(pig, PigAssaultShieldMonitor[i]);
	return res;
}

int GetAspectRatio(void) {
	int width = getcvar("vid_defwidth");
	int height = getcvar("vid_defheight");
	int nowidescreen = getcvar("vid_nowidescreen");
	int tft = getcvar("vid_tft");
	int aspect = getcvar("vid_aspect");
	switch(aspect) {
		case 1:	return ASPECT_16_9;
		case 2:	return ASPECT_16_10;
		case 3:	return ASPECT_4_3;
		case 4:	return ASPECT_5_4;
	}
	if(nowidescreen) {
		if(!tft)
			return ASPECT_4_3;
		if(fixedmul(height<<16, fixeddiv(5.0, 4.0)) == width<<16)
			return ASPECT_5_4;
		else
			return ASPECT_4_3;
	}
	if(abs((abs(fixedmul(height<<16, fixeddiv(16.0, 9.0)))>>16) - width) < 10) {
		return ASPECT_16_9;
	}
	if(abs((abs(fixedmul(height<<16, fixeddiv(16.0, 10.0)))>>16) - width) < 60) {
		if((width == 320 && height == 200) || (width == 640 && height == 400))
			return ASPECT_4_3;
		return ASPECT_16_10;
	}
	if(fixedmul(height<<16, fixeddiv(5.0, 4.0))>>16 == width && tft) {
		return ASPECT_5_4;
	}
	return ASPECT_4_3;
}

#endif